// SampleCtrl.h : Declaration of the CSampleCtrl

#ifndef __SAMPLECTRL_H_
#define __SAMPLECTRL_H_

#include "resource.h"       // main symbols
#include <atlctl.h>


/////////////////////////////////////////////////////////////////////////////
// CSampleCtrl
class ATL_NO_VTABLE CSampleCtrl : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public IDispatchImpl<ISampleCtrl, &IID_ISampleCtrl, &LIBID_ATLTESTLib>,
	public CComControl<CSampleCtrl>,
	public IPersistStreamInitImpl<CSampleCtrl>,
	public IOleControlImpl<CSampleCtrl>,
	public IOleObjectImpl<CSampleCtrl>,
	public IOleInPlaceActiveObjectImpl<CSampleCtrl>,
	public IViewObjectExImpl<CSampleCtrl>,
	public IOleInPlaceObjectWindowlessImpl<CSampleCtrl>,
	public ISupportErrorInfo,
	public IConnectionPointContainerImpl<CSampleCtrl>,
	public IPersistStorageImpl<CSampleCtrl>,
	public ISpecifyPropertyPagesImpl<CSampleCtrl>,
	public IQuickActivateImpl<CSampleCtrl>,
	public IDataObjectImpl<CSampleCtrl>,
	public IProvideClassInfo2Impl<&CLSID_SampleCtrl, &DIID__ISampleCtrlEvents, &LIBID_ATLTESTLib>,
	public IPropertyNotifySinkCP<CSampleCtrl>,
	public CComCoClass<CSampleCtrl, &CLSID_SampleCtrl>,
	public IPersistPropertyBagImpl<CSampleCtrl> //IPersistPropertyBag Ƽ ߰ 

{
public:
	CSampleCtrl()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_SAMPLECTRL)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CSampleCtrl)
	COM_INTERFACE_ENTRY(ISampleCtrl)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY(IViewObject2)
	COM_INTERFACE_ENTRY(IViewObject)
	COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceObject)
	COM_INTERFACE_ENTRY2(IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY(IOleControl)
	COM_INTERFACE_ENTRY(IOleObject)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
	COM_INTERFACE_ENTRY2(IPersist, IPersistStreamInit)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
	COM_INTERFACE_ENTRY(ISpecifyPropertyPages)
	COM_INTERFACE_ENTRY(IQuickActivate)
	COM_INTERFACE_ENTRY(IPersistStorage)
	COM_INTERFACE_ENTRY(IDataObject)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
	COM_INTERFACE_ENTRY(IPersistPropertyBag)  
END_COM_MAP()

BEGIN_PROP_MAP(CSampleCtrl)
	PROP_DATA_ENTRY("_cx", m_sizeExtent.cx, VT_UI4)
	PROP_DATA_ENTRY("_cy", m_sizeExtent.cy, VT_UI4)
	PROP_ENTRY("DisplayString", 1, GetObjectCLSID()) 
	// Example entries
	// PROP_ENTRY("Property Description", dispid, clsid)
	// PROP_PAGE(CLSID_StockColorPage)
END_PROP_MAP()

BEGIN_CONNECTION_POINT_MAP(CSampleCtrl)
	CONNECTION_POINT_ENTRY(IID_IPropertyNotifySink)
END_CONNECTION_POINT_MAP()

BEGIN_MSG_MAP(CSampleCtrl)
	CHAIN_MSG_MAP(CComControl<CSampleCtrl>)
	DEFAULT_REFLECTION_HANDLER()
END_MSG_MAP()
// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);



// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid)
	{
		static const IID* arr[] = 
		{
			&IID_ISampleCtrl,
		};
		for (int i=0; i<sizeof(arr)/sizeof(arr[0]); i++)
		{
			if (InlineIsEqualGUID(*arr[i], riid))
				return S_OK;
		}
		return S_FALSE;
	}

// IViewObjectEx
	DECLARE_VIEW_STATUS(VIEWSTATUS_SOLIDBKGND | VIEWSTATUS_OPAQUE)

// ISampleCtrl
public:
	STDMETHOD(get_DisplayString)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(put_DisplayString)(/*[in]*/ BSTR newVal);

	HRESULT OnDraw(ATL_DRAWINFO& di)
	{
		RECT& rc = *(RECT*)di.prcBounds;
		Rectangle(di.hdcDraw, rc.left, rc.top, rc.right, rc.bottom);

		SetTextAlign(di.hdcDraw, TA_CENTER|TA_BASELINE);
		//LPCTSTR pszText = _T("ATL 3.0 : SampleCtrl");
		char szString[MAX_PATH];
		WideCharToMultiByte(949, 0, (LPCWSTR)m_DisplayString, -1, szString, MAX_PATH, NULL, NULL);
		TextOut(di.hdcDraw, 
			(rc.left + rc.right) / 2, 
			(rc.top + rc.bottom) / 2, 
			szString, 
		lstrlen(szString));
		
		return S_OK;
	}
private:
	CComBSTR m_DisplayString;
};

#endif //__SAMPLECTRL_H_
